package generated.geldkarteAsymm.javacard.geldkarte;

import javacard.framework.*;
import javacard.security.RandomData;
import javacardx.crypto.Cipher;

public class EncDataAsymm extends EncData {

	private final static short RSABLOCKLENGTH = 128;

	private static RandomData rd;

	public EncDataAsymm() {
		encrypted = new byte[Store.MAXENCRYPTLENGTHASYMM];
		tmparray = new byte[Store.MAXENCRYPTLENGTHASYMM];

		c = Cipher.getInstance(Cipher.ALG_RSA_NOPAD, false);
		if (rd == null)
			rd = RandomData.getInstance(RandomData.ALG_SECURE_RANDOM);

	}

	public byte getCode() {
		return Code.ENCDATAASYMM;
	}

	public boolean isEncDataAsymm() {
		return true;
	}

	// ********************************************************

	public static EncDataAsymm encrypt(PublicKey key, PlainData d) {
		return Store.newEncDataAsymm().instEncrypt(key, d);
	}

	public EncDataAsymm instEncrypt(PublicKey key, PlainData d) {
		plainDataType = d.getCode();
		Coding.getInstance().encode(d, tmparray);
		plainlength = Coding.getInstance().getEncodingLength();
		enclength = RSABLOCKLENGTH;

		padBuffer(tmparray, (short) 0, plainlength, enclength);
		c.init(key.toAPIKey(), Cipher.MODE_ENCRYPT);
		c.doFinal(tmparray, (short) 0, plainlength, encrypted, (short) 0);

		return this;
	}
	// ********************************************************

	private void padBuffer(byte[] buffer, short offset, short len,
			short paddedlen) {
		if (paddedlen != len)
			rd.generateData(buffer, (short) (offset + len),
					(short) (paddedlen - len));
	}

	private boolean check() {
		if (!(0 < plainlength && plainlength <= enclength && enclength <= encrypted.length))
			return false;
		return enclength == RSABLOCKLENGTH;
	}

	public static PlainData decrypt(PrivateKey key, EncDataAsymm e) {
		return e.decrypt(key);
	}

	public PlainData decrypt(PrivateKey key) {
		if (!check())

			SimpleComm.raiseError();

		c.init(key.toAPIKey(), Cipher.MODE_DECRYPT);
		c.doFinal(encrypted, (short) 0, enclength, tmparray, (short) 0);

		return Coding.getInstance().decodePlainData(tmparray, plainDataType);
	}

}
