package generated.geldkarteAsymm.javacard.geldkarte;

import javacard.framework.*;

/**
 * Generated Smartcard for GeldkarteAsymm model
 */
public class Geldkarte extends SimpleComm {

	public short balance;
	public PrivateKey privKey;
	public byte state;
	public Certificate pubKey;
	public SignedData cert;

	/**
	 * Constructor
	 */
	public Geldkarte() {
		balance = 0;
		privKey = new PrivateKey();
		state = State.APPLET_UNINITIALIZED;
		pubKey = new Certificate();
		cert = new SignedData();
	}

	public void appletInitialization(byte[] buf, short offset) {
		if (state != State.APPLET_UNINITIALIZED)
			stop();
		Coding.getInstance().decodeGeldkarte(buf, offset, this);
	}

	/**
	 * This init method is used for testcases to quickly initialize a card
	 */
	public Geldkarte init(short balance, SignedData cert, PrivateKey privKey,
			Certificate pubKey, byte state) {

		this.balance = balance;
		this.cert = cert;
		this.privKey = privKey;
		this.pubKey = pubKey;
		this.state = state;

		return this;
	}

	public Geldkarte init() {
		balance = 0;
		privKey = new PrivateKey();
		state = State.IDLE;
		pubKey = new Certificate();
		cert = new SignedData();

		return this;
	}

	/**
	 * process-method, is called from SimpleComm when a message arrives
	 * 
	 * @param inmsg message to process
	 */
	public void process(Message inmsg) {
		if (state == State.APPLET_UNINITIALIZED)
			stop();

		currentGate.callConstraints();

		switch (inmsg.getCode()) {
			case Code.GETKEY :
				processGetKey((GetKey) inmsg);
				break;
			case Code.PAY :
				processPay((Pay) inmsg);
				break;
			//Unknown Message
			default :
				stop();
		}

		currentGate.callConstraints();
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processGetKey(GetKey inmsg) {

		sendMsg(Store.newSendKey(pubKey, cert));
	}

	/**
	 * This method is called, when a -message arrives.
	 * Parameters are a result of the activity diagrams
	 */
	public void processPay(Pay inmsg) {
		EncDataAsymm e = inmsg.data;
		PayData pd = (PayData) (EncDataAsymm.decrypt(privKey, e));
		if (((pd.amount >= (short) 0) && (balance >= pd.amount))) {
			balance = Math.minus(balance, pd.amount);
			SignedData s = SignedData.sign(privKey, pd);
			sendMsg(Store.newPaySig(s));
		} else {
			stop();
		}
	}

}
