package generated.geldkarteAsymm.javacard.geldkarte;

import javacard.framework.APDU;
import javacard.framework.Applet;
import javacard.framework.ISO7816;
import javacard.framework.ISOException;
import javacard.framework.Util;

public abstract class SimpleComm extends Applet {

	public final static byte INIT_INSTRUCTION = 4;

	public final static byte RESUME_INSTRUCTION = 6;

	public final static short ENCBUF_MAXLEN = 562;

	public final static short DECBUF_MAXLEN = 562;

	public final static short APDU_MAXLEN = 255;

	public final static short OUTMSG_MAXLEN = 254;

	protected static Coding coding;

	private Message inmsg;
	private static Message outmsg;
	protected byte[] encodebuffer; //buffer to encode messages
	protected byte[] decodebuffer; //buffer to decode messages
	private short len = 0;

	//bytes we've already sent/received
	private static short encbuf_sentlen = 0;
	private static short decbuf_receivedlen = 0;

	// buffer containing the previously received message (for testcases)
	public byte[] prevMsg;
	public short prevMsgLen;

	/* Gate initialization */
	public static Gate dummyGate;

	public static Gate currentGate;

	/**
	 * called by JCRE
	 */

	public void process(APDU apdu)

	{
		if (selectingApplet())
			return;
		short expected = apdu.setIncomingAndReceive();
		if (expected == 0)
			ISOException.throwIt(ISO7816.SW_CONDITIONS_NOT_SATISFIED);
		byte ins = apdu.getBuffer()[ISO7816.OFFSET_INS];

		if (ins == RESUME_INSTRUCTION) {
			currentGate.sendAPDU(this, apdu, encodebuffer,
					(short) (len - encbuf_sentlen), false);
			return;
		}

		//Buffer boundaries shouldn't be overstepped
		if ((short) (decbuf_receivedlen + expected) > DECBUF_MAXLEN) {
			decbuf_receivedlen = 0;
			ISOException.throwIt(ISO7816.SW_CONDITIONS_NOT_SATISFIED);
			return;
		}

		//Handle long APDUs
		Util.arrayCopy(apdu.getBuffer(), ISO7816.OFFSET_CDATA, decodebuffer,
				decbuf_receivedlen, expected);
		decbuf_receivedlen += expected;
		if (apdu.getBuffer()[ISO7816.OFFSET_P1] == 1)
			return;

		if (ins == INIT_INSTRUCTION) {
			appletInitialization(decodebuffer, (short) 0);
			decbuf_receivedlen = 0;
			return;
		}

		Store.reset();
		outmsg = null;

		// save received msg
		prevMsg = decodebuffer;
		prevMsgLen = decbuf_receivedlen;

		inmsg = coding.decodeMessage(decodebuffer, (short) 0,
				decbuf_receivedlen);
		decbuf_receivedlen = 0;

		process(inmsg);
		if (outmsg != null) {
			len = coding.encode((Codeable) outmsg, encodebuffer);
			encbuf_sentlen = 0;
			currentGate.sendAPDU(this, apdu, encodebuffer, len, true);
		} else
			currentGate.finishProtocol(this);

	}

	public abstract void process(Message msg)

	;

	protected static void sendMsg(Message msg)

	{
		currentGate.callConstraints();

		outmsg = msg;
	}

	/**
	 * Resets the current gate to a default dummy gate
	 */

	public void resetGate()

	{
		currentGate = dummyGate;
	}

	public void setGate(Gate gate)

	{
		currentGate = gate;
	}

	public void sendAPDU(APDU apdu, byte[] data, short rem_len, boolean first)

	{

		if (!first && encbuf_sentlen >= len)
			return;
		byte[] buffer = apdu.getBuffer();
		short sendLen = 0;
		if (rem_len > OUTMSG_MAXLEN) {
			buffer[0] = 1;
			Util.arrayCopy(data, encbuf_sentlen, buffer, (short) 1,
					OUTMSG_MAXLEN);
			encbuf_sentlen += OUTMSG_MAXLEN;
			sendLen = APDU_MAXLEN;
		} else {
			buffer[0] = 0;
			Util.arrayCopy(data, encbuf_sentlen, buffer, (short) 1, rem_len);
			encbuf_sentlen = len;
			sendLen = (short) (rem_len + 1);
		}
		apdu.setOutgoingAndSend((short) 0, sendLen);
	}

	public abstract void appletInitialization(byte[] buf, short offset)

	;

	/**
	 * called by Java Card virtual machine.
	 */

	public static void install(byte[] bArray, short bOffset, byte bLength)

	{
		new Geldkarte();

		dummyGate = new DummyGate();
		currentGate = dummyGate;

	}

	/**
	 * Method called when a modeled flowFinal is reached
	 */

	public void stop()

	{
		currentGate.callConstraints();
		ISOException.throwIt(ISO7816.SW_CONDITIONS_NOT_SATISFIED);
	}

	public static void raiseError()

	{
		currentGate.callConstraints();

		ISOException.throwIt(ISO7816.SW_CONDITIONS_NOT_SATISFIED);
	}

	/**
	 * Constructor. Registers the applet
	 */
	public SimpleComm() {
		coding = Coding.getInstance();
		// currentGate = dummyGate;
		//LONGAPDU
		encodebuffer = new byte[ENCBUF_MAXLEN];
		decodebuffer = new byte[DECBUF_MAXLEN];
		Store.initAll();
		register();
	}

}
