package generated.geldkarteAsymm.terminal.merchant;

import java.security.*;
import javax.crypto.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
@XmlAccessorType(XmlAccessType.FIELD)
public class EncDataAsymm extends EncData {

	private final static short RSABLOCKLENGTH = 128;

	private final static String cryptProvider = "BC";

	public EncDataAsymm() {
		encrypted = new byte[LengthConstants.MAXENCRYPTLENGTHASYMM];
		tmparray = new byte[LengthConstants.MAXENCRYPTLENGTHASYMM];

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());

	}

	public byte getCode() {
		return Code.ENCDATAASYMM;
	}

	public boolean isEncDataAsymm() {
		return true;
	}

	// ********************************************************

	public static EncDataAsymm encrypt(PublicKey key, PlainData d)
			throws Exception {
		return (new EncDataAsymm()).instEncrypt(key, d);
	}

	public EncDataAsymm instEncrypt(PublicKey key, PlainData d)
			throws Exception {
		plainDataType = d.getCode();
		Coding.getInstance().encode(d, tmparray);
		plainlength = Coding.getInstance().getEncodingLength();
		enclength = RSABLOCKLENGTH;

		c = Cipher.getInstance("RSA", cryptProvider);
		c.init(Cipher.ENCRYPT_MODE, key.toAPIKey());
		c.doFinal(tmparray, 0, enclength, encrypted, 0);

		return this;
	}
	// ********************************************************

	private boolean check() {
		if (!(0 < plainlength && plainlength <= enclength && enclength <= encrypted.length))
			return false;
		return enclength == RSABLOCKLENGTH;
	}

	public static PlainData decrypt(PrivateKey key, EncDataAsymm e)
			throws Exception {
		return e.decrypt(key);
	}

	public PlainData decrypt(PrivateKey key) throws Exception {
		if (!check())
			stop();

		c = Cipher.getInstance("RSA", cryptProvider);
		c.init(Cipher.DECRYPT_MODE, key.toAPIKey());
		c.doFinal(encrypted, 0, enclength, tmparray, 0);

		return Coding.getInstance().decodePlainData(tmparray, plainDataType);
	}

	private void stop() throws TerminalException {
		throw new TerminalException("EncDataAsymm");
	}

	public EncDataAsymm copy() {
		EncDataAsymm object = new EncDataAsymm();
		object.copy(this);
		return object;
	}

}
