package generated.geldkarteAsymm.terminal.merchant;

import java.math.BigInteger;
import java.security.spec.InvalidKeySpecException;
import java.security.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
@XmlAccessorType(XmlAccessType.FIELD)
public class PrivateKey extends Key implements Codeable, PlainData, SignData {

	public final static short MODULUSLENGTH = 128;
	public final static short EXPONENTLENGTH = 128;

	public final static String cryptProvider = "BC";

	private byte[] modulus;
	private byte[] privexponent;

	private static final byte[] defaultModulus = new byte[]{(byte) 0x95,
			(byte) 0x5D, (byte) 0x7D, (byte) 0x9F, (byte) 0xEB, (byte) 0x31,
			(byte) 0xFF, (byte) 0xBD, (byte) 0xBE, (byte) 0x0C, (byte) 0x1C,
			(byte) 0x5B, (byte) 0x53, (byte) 0x37, (byte) 0x1B, (byte) 0xBB,
			(byte) 0xDB, (byte) 0xFB, (byte) 0x7D, (byte) 0x83, (byte) 0x07,
			(byte) 0x41, (byte) 0x73, (byte) 0xE1, (byte) 0xDA, (byte) 0x82,
			(byte) 0x2F, (byte) 0x7A, (byte) 0xB6, (byte) 0x7B, (byte) 0xC9,
			(byte) 0x5D, (byte) 0x16, (byte) 0x52, (byte) 0xAE, (byte) 0xCD,
			(byte) 0x27, (byte) 0xFF, (byte) 0x40, (byte) 0x5C, (byte) 0xEC,
			(byte) 0x8A, (byte) 0xA2, (byte) 0x0D, (byte) 0xDB, (byte) 0x16,
			(byte) 0x59, (byte) 0x95, (byte) 0x99, (byte) 0x4D, (byte) 0x11,
			(byte) 0xAC, (byte) 0xC5, (byte) 0x28, (byte) 0x73, (byte) 0x05,
			(byte) 0x49, (byte) 0x1B, (byte) 0x03, (byte) 0xA4, (byte) 0x43,
			(byte) 0x9F, (byte) 0x8F, (byte) 0x3A, (byte) 0x84, (byte) 0x08,
			(byte) 0x55, (byte) 0x08, (byte) 0xB3, (byte) 0xB2, (byte) 0xFE,
			(byte) 0x2F, (byte) 0xDD, (byte) 0x65, (byte) 0xE2, (byte) 0x98,
			(byte) 0x4F, (byte) 0xBF, (byte) 0x3A, (byte) 0xE7, (byte) 0xE3,
			(byte) 0x3D, (byte) 0xA8, (byte) 0x71, (byte) 0x7F, (byte) 0xDE,
			(byte) 0x99, (byte) 0x2F, (byte) 0xE2, (byte) 0xE6, (byte) 0x67,
			(byte) 0x7F, (byte) 0x9E, (byte) 0xFA, (byte) 0xDE, (byte) 0x7E,
			(byte) 0x60, (byte) 0xE2, (byte) 0xE4, (byte) 0x17, (byte) 0x10,
			(byte) 0xA1, (byte) 0x4B, (byte) 0xF4, (byte) 0x31, (byte) 0xD8,
			(byte) 0x5C, (byte) 0x88, (byte) 0x05, (byte) 0x7F, (byte) 0xD4,
			(byte) 0x38, (byte) 0x90, (byte) 0xF4, (byte) 0x72, (byte) 0x39,
			(byte) 0xA6, (byte) 0xA8, (byte) 0xA8, (byte) 0xA6, (byte) 0x4E,
			(byte) 0xF1, (byte) 0xD2, (byte) 0x6F, (byte) 0x63, (byte) 0x97,
			(byte) 0xDA, (byte) 0x9B};
	private static final byte[] defaultExponent = new byte[]{(byte) 0x23,
			(byte) 0xBD, (byte) 0xA5, (byte) 0x4B, (byte) 0xD8, (byte) 0xF9,
			(byte) 0xB3, (byte) 0xDA, (byte) 0x71, (byte) 0x59, (byte) 0x70,
			(byte) 0x87, (byte) 0xA1, (byte) 0xD7, (byte) 0xF3, (byte) 0xF8,
			(byte) 0xF5, (byte) 0xE0, (byte) 0xAD, (byte) 0xDD, (byte) 0xE6,
			(byte) 0xA4, (byte) 0x90, (byte) 0xD8, (byte) 0x20, (byte) 0x73,
			(byte) 0x3A, (byte) 0x6D, (byte) 0x40, (byte) 0xB1, (byte) 0x4A,
			(byte) 0x33, (byte) 0xCE, (byte) 0x1D, (byte) 0xA6, (byte) 0xDA,
			(byte) 0x4C, (byte) 0x91, (byte) 0xD5, (byte) 0x92, (byte) 0xE6,
			(byte) 0xBF, (byte) 0x1D, (byte) 0x9B, (byte) 0xF7, (byte) 0x2A,
			(byte) 0xD7, (byte) 0xF0, (byte) 0xE6, (byte) 0x27, (byte) 0xFC,
			(byte) 0xEC, (byte) 0xBC, (byte) 0x98, (byte) 0xBB, (byte) 0x3D,
			(byte) 0x2E, (byte) 0x8B, (byte) 0x1A, (byte) 0x49, (byte) 0xFA,
			(byte) 0x2C, (byte) 0x7A, (byte) 0x17, (byte) 0x05, (byte) 0x66,
			(byte) 0x06, (byte) 0x41, (byte) 0x21, (byte) 0x90, (byte) 0x26,
			(byte) 0x2C, (byte) 0xB0, (byte) 0x25, (byte) 0xA3, (byte) 0x1A,
			(byte) 0x3E, (byte) 0xB2, (byte) 0x40, (byte) 0xC5, (byte) 0xB3,
			(byte) 0xD0, (byte) 0xC3, (byte) 0x6C, (byte) 0x62, (byte) 0x39,
			(byte) 0x6E, (byte) 0x91, (byte) 0x99, (byte) 0x57, (byte) 0xBF,
			(byte) 0x12, (byte) 0x9C, (byte) 0xD2, (byte) 0x5B, (byte) 0xF1,
			(byte) 0xA0, (byte) 0x79, (byte) 0x5B, (byte) 0xEA, (byte) 0x5C,
			(byte) 0x47, (byte) 0xC2, (byte) 0x83, (byte) 0xD2, (byte) 0x67,
			(byte) 0x17, (byte) 0x72, (byte) 0xE8, (byte) 0x78, (byte) 0x5D,
			(byte) 0x23, (byte) 0x5C, (byte) 0x83, (byte) 0x4A, (byte) 0xD3,
			(byte) 0x1F, (byte) 0x7D, (byte) 0xC1, (byte) 0x60, (byte) 0x64,
			(byte) 0x5E, (byte) 0x59, (byte) 0x4E, (byte) 0x6A, (byte) 0x8C,
			(byte) 0xF4, (byte) 0x11};

	public PrivateKey() {

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());
		try {
			setKey(defaultModulus, defaultExponent);
		} catch (Exception e) {
		}

	}

	public PrivateKey(byte[] modulus, byte[] privexp)
			throws InvalidKeySpecException, NoSuchAlgorithmException,
			NoSuchProviderException {
		this();

		setKey(modulus, privexp);

	}

	public boolean equals(PrivateKey other) {
		return Arrays.equals(modulus, other.modulus)
				&& Arrays.equals(privexponent, other.privexponent);
	}

	public byte getCode() {
		return Code.PRIVATEKEY;
	}

	public void setKey(byte[] modulus, byte[] privexp)
			throws InvalidKeySpecException, NoSuchAlgorithmException,
			NoSuchProviderException {
		this.modulus = modulus.clone();
		this.privexponent = privexp.clone();
	}

	public java.security.PrivateKey toAPIKey() throws Exception {
		BigInteger mod = new BigInteger(1, this.modulus);
		BigInteger priv = new BigInteger(1, this.privexponent);
		KeyFactory rsakf = KeyFactory.getInstance("RSA", cryptProvider);
		java.security.PrivateKey apikey = (java.security.PrivateKey) rsakf
				.generatePrivate(new java.security.spec.RSAPrivateKeySpec(mod,
						priv));
		return apikey;
	}

	public byte[] getModulus() {
		return modulus;
	}

	public byte[] getPrivexponent() {
		return privexponent;
	}

	public void copy(PrivateKey p) {

		if (p.getModulus() != null && p.getPrivexponent() != null) {
			try {
				setKey(p.getModulus(), p.getPrivexponent());
			} catch (InvalidKeySpecException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchAlgorithmException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

	public boolean isPrivateKey() {
		return true;
	}

}
