package generated.geldkarteAsymm.terminal.merchant;

import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.Signature;
import java.security.SignatureException;
import swt.util.ByteArray;
import java.security.Security;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
@XmlAccessorType(XmlAccessType.FIELD)
public class SignedData implements Codeable, PlainData, SignData {

	private byte[] signed;
	public static final short signedlength = 128; // ALG_RSA_SHA_PKCS1

	private static byte[] tmparray;

	public short signlength;

	public byte signDataType;

	public final static String cryptProvider = "BC";

	public SignedData() {

		Security.addProvider(new org.bouncycastle.jce.provider.BouncyCastleProvider());
		tmparray = new byte[LengthConstants.MAX_ENCODING_LENGTH_SIGNDATA]; //length = max length of encoded SignData
	}

	public boolean equals(SignedData o) {

		if (signlength != o.signlength || signDataType != o.signDataType)

			return false;
		return Arrays.equals(this.signed, o.signed);
	}

	public byte getCode() {
		return Code.SIGNEDDATA;
	}

	public byte[] getSigned() {
		return signed;
	}

	public void setSigned(byte[] src) {
		this.signed = src.clone();
	}

	public void copy(SignedData o) {

		signlength = o.signlength;
		signDataType = o.signDataType;
		setSigned(o.signed);
	}

	// ********************************************************
	public static SignedData sign(PrivateKey key, SignData d) throws Exception {
		return (new SignedData()).instSign(key, d);
	}

	public SignedData instSign(PrivateKey key, SignData d) throws Exception {

		signDataType = d.getCode();

		Coding.getInstance().encode(d, tmparray);
		signlength = Coding.getInstance().getEncodingLength();

		Signature sig = Signature.getInstance("SHA1withRSA", cryptProvider);
		sig.initSign(key.toAPIKey());
		sig.update(ByteArray.subarray(tmparray, 0, signlength));
		signed = sig.sign();

		return this;
	}
	// ********************************************************

	private boolean check() {
		if (!(signedlength <= signed.length))
			return false;
		else
			return true;
	}

	public static boolean verify(PublicKey key, SignedData sd, SignData s)
			throws Exception {

		return sd.verify(key, s);
	}

	public boolean verify(PublicKey key, SignData s) throws Exception {
		if (!check())

			return false;
		Coding.getInstance().encode(s, tmparray);
		Signature sig = Signature.getInstance("SHA1withRSA", cryptProvider);
		sig.initVerify(key.toAPIKey());
		signlength = Coding.getInstance().getEncodingLength();
		sig.update(ByteArray.subarray(tmparray, 0, signlength));
		return sig.verify(ByteArray.subarray(signed, 0, signedlength));

	}
}
